Public Class Form1
    Private Sub tbar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbarJoint1.Scroll, tbarJoint2.Scroll, tbarJoint3.Scroll
        picCanvas.Invalidate()
    End Sub

    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        Const ARM_LENGTH_1 As Integer = 75
        Const ARM_LENGTH_2 As Integer = 50
        Const ARM_LENGTH_3 As Integer = 50

        e.Graphics.Clear(Me.BackColor)

        Dim cx As Double = picCanvas.ClientSize.Width / 2
        Dim cy As Double = picCanvas.ClientSize.Height / 2

        ' Make sure we start from scratch.
        e.Graphics.ResetTransform()

        ' For each stage in the arm, draw and then *prepend* the
        ' new transformation to represent the next arm in the sequence.

        ' Translate to center of form.
        e.Graphics.TranslateTransform(cx, cy)

        ' Draw the shoulder centered at the origin.
        e.Graphics.DrawEllipse(Pens.Red, -4, -4, 9, 9)

        ' Rotate at the shoulder.
        ' (Negative to make the angle increase counter-clockwise).
        e.Graphics.RotateTransform(-tbarJoint1.Value, Drawing2D.MatrixOrder.Prepend)

        ' Draw the first arm.
        e.Graphics.DrawRectangle(Pens.Blue, 0, -1, ARM_LENGTH_1, 3)

        ' Translate to the end of the first arm.
        e.Graphics.TranslateTransform(ARM_LENGTH_1, 0, Drawing2D.MatrixOrder.Prepend)

        ' Draw the elbow.
        e.Graphics.DrawEllipse(Pens.Red, -4, -4, 9, 9)

        ' Rotate at the elbow.
        e.Graphics.RotateTransform(-tbarJoint2.Value, Drawing2D.MatrixOrder.Prepend)

        ' Draw the second arm.
        e.Graphics.DrawRectangle(Pens.Blue, 0, -1, ARM_LENGTH_2, 3)

        ' Translate to the end of the second arm.
        e.Graphics.TranslateTransform(ARM_LENGTH_2, 0, Drawing2D.MatrixOrder.Prepend)

        ' Draw the wrist.
        e.Graphics.DrawEllipse(Pens.Red, -4, -4, 9, 9)

        ' Rotate at the wrist.
        e.Graphics.RotateTransform(-tbarJoint3.Value, Drawing2D.MatrixOrder.Prepend)

        ' Draw the third arm.
        e.Graphics.DrawRectangle(Pens.Blue, 0, -1, ARM_LENGTH_3, 3)
    End Sub
End Class
